InfoGrab Docs

그룹 수준 보호된 브랜치 API

요약

이 API를 사용하여 그룹의 모든 프로젝트가 상속하는 보호된 브랜치 설정을 관리합니다. 그룹의 보호된 브랜치 설정은 최상위 그룹으로만 제한됩니다. 접근 수준은 ProtectedRefAccess.allowed_access_levels 메서드에 정의되어 있습니다.

히스토리
  • GitLab 17.6에서 일반 공개되었습니다. 기능 플래그 group_protected_branches가 제거되었습니다.

이 API를 사용하여 그룹의 모든 프로젝트가 상속하는 보호된 브랜치 설정을 관리합니다. 그룹 보호된 브랜치는 유효한 접근 수준만 지원합니다. 개별 사용자와 그룹은 지정할 수 없습니다.

Warning

그룹의 보호된 브랜치 설정은 최상위 그룹으로만 제한됩니다.

유효한 접근 수준#

접근 수준은 ProtectedRefAccess.allowed_access_levels 메서드에 정의되어 있습니다. 다음 수준이 인식됩니다:

0  => 접근 없음
30 => Developer 접근
40 => Maintainer 접근
60 => Admin 접근

보호된 브랜치 목록 조회#

그룹에서 보호된 브랜치 목록을 가져옵니다. 와일드카드가 설정된 경우 해당 와일드카드와 일치하는 브랜치의 정확한 이름 대신 와일드카드가 반환됩니다.

GET /groups/:id/protected_branches
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
search 문자열 아니요 검색할 보호된 브랜치의 이름 또는 이름의 일부.
curl --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches"

응답 예시:

[
  {
    "id": 1,
    "name": "main",
    "push_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "merge_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
  },
  {
    "id": 1,
    "name": "release/*",
    "push_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "merge_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
  },
  ...
]

단일 보호된 브랜치 또는 와일드카드 보호된 브랜치 가져오기#

단일 보호된 브랜치 또는 와일드카드 보호된 브랜치를 가져옵니다.

GET /groups/:id/protected_branches/:name
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치 이름 또는 와일드카드.
curl --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/main"

응답 예시:

{
  "id": 1,
  "name": "main",
  "push_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "merge_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "allow_force_push":false,
  "code_owner_approval_required": false
}

저장소 브랜치 보호#

와일드카드 보호된 브랜치를 사용하여 단일 저장소 브랜치를 보호합니다.

POST /groups/:id/protected_branches
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches?name=*-stable&push_access_level=30&merge_access_level=30&unprotect_access_level=40"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치 이름 또는 와일드카드.
allow_force_push 불리언 아니요 푸시 접근 권한이 있는 모든 사용자가 강제 푸시할 수 있도록 허용합니다. 기본값: false.
allowed_to_merge 배열 아니요 머지가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
allowed_to_push 배열 아니요 푸시가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
allowed_to_unprotect 배열 아니요 보호 해제가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
code_owner_approval_required 불리언 아니요 CODEOWNERS 파일의 항목과 일치하는 경우 이 브랜치로의 푸시를 방지합니다. 기본값: false.
merge_access_level 정수 아니요 머지가 허용된 접근 수준. 기본값: 40, Maintainer 역할.
push_access_level 정수 아니요 푸시가 허용된 접근 수준. 기본값: 40, Maintainer 역할.
unprotect_access_level 정수 아니요 보호 해제가 허용된 접근 수준. 기본값: 40, Maintainer 역할.

응답 예시:

{
  "id": 1,
  "name": "*-stable",
  "push_access_levels": [
    {
      "id":  1,
      "access_level": 30,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Developers + Maintainers"
    }
  ],
  "merge_access_levels": [
    {
      "id":  1,
      "access_level": 30,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Developers + Maintainers"
    }
  ],
  "unprotect_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "allow_force_push":false,
  "code_owner_approval_required": false
}

접근 수준을 사용한 예시#

접근 수준을 사용하여 그룹 보호된 브랜치를 구성합니다:

curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --data '{
    "name": "main",
    "allowed_to_push": [{"access_level": 30}],
    "allowed_to_merge": [{
        "access_level": 30
      },{
        "access_level": 40
      }
    ]}'
    --url "https://gitlab.example.com/api/v4/groups/5/protected_branches"

응답 예시:

{
    "id": 5,
    "name": "main",
    "push_access_levels": [
        {
            "id": 1,
            "access_level": 30,
            "access_level_description": "Developers + Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "merge_access_levels": [
        {
            "id": 1,
            "access_level": 30,
            "access_level_description": "Developers + Maintainers",
            "user_id": null,
            "group_id": null
        },
        {
            "id": 2,
            "access_level": 40,
            "access_level_description": "Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "unprotect_access_levels": [
        {
            "id": 1,
            "access_level": 40,
            "access_level_description": "Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
}

저장소 브랜치 보호 해제#

지정된 보호된 브랜치 또는 와일드카드 보호된 브랜치의 보호를 해제합니다.

DELETE /groups/:id/protected_branches/:name
curl --request DELETE \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/*-stable"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치의 이름.

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 40,
         "access_level_description": "Maintainers",
         "user_id": null,
         "group_id": null
      }
   ]
}

보호된 브랜치 업데이트#

보호된 브랜치를 업데이트합니다.

PATCH /groups/:id/protected_branches/:name
curl --request PATCH \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/feature-branch?allow_force_push=true&code_owner_approval_required=true"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치의 이름.
allow_force_push 불리언 아니요 활성화되면 이 브랜치에 푸시할 수 있는 구성원도 강제 푸시할 수 있습니다.
allowed_to_push 배열 아니요 해시로 설명된 푸시 접근 수준의 배열.
allowed_to_merge 배열 아니요 해시로 설명된 머지 접근 수준의 배열.
allowed_to_unprotect 배열 아니요 해시로 설명된 보호 해제 접근 수준의 배열.
code_owner_approval_required 불리언 아니요 CODEOWNERS 파일의 항목과 일치하는 경우 이 브랜치로의 푸시를 방지합니다. 기본값: false.

allowed_to_push, allowed_to_mergeallowed_to_unprotect 배열의 요소는 {access_level: integer} 형식이어야 합니다. 각 접근 수준은 유효한 접근 수준에서 유효한 값이어야 합니다.

  • 접근 수준을 업데이트하려면 해당 해시에서 access_levelid도 전달해야 합니다.
  • 접근 수준을 삭제하려면 _destroytrue로 설정하여 전달해야 합니다. 다음 예시를 참조하세요.

예시: push_access_level 레코드 생성#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{access_level: 40}]}' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 40,
         "access_level_description": "Maintainers",
         "user_id": null,
         "group_id": null
      }
   ]
}

예시: push_access_level 레코드 업데이트#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{"id": 12, "access_level": 0}]' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 0,
         "access_level_description": "No One",
         "user_id": null,
         "group_id": null
      }
   ]
}

예시: push_access_level 레코드 삭제#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{"id": 12, "_destroy": true}]}' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": []
}

그룹 수준 보호된 브랜치 API

Tier: Premium, Ultimate
Offering: GitLab Self-Managed
원문 보기
요약

이 API를 사용하여 그룹의 모든 프로젝트가 상속하는 보호된 브랜치 설정을 관리합니다. 그룹의 보호된 브랜치 설정은 최상위 그룹으로만 제한됩니다. 접근 수준은 ProtectedRefAccess.allowed_access_levels 메서드에 정의되어 있습니다.

히스토리
  • GitLab 17.6에서 일반 공개되었습니다. 기능 플래그 group_protected_branches가 제거되었습니다.

이 API를 사용하여 그룹의 모든 프로젝트가 상속하는 보호된 브랜치 설정을 관리합니다. 그룹 보호된 브랜치는 유효한 접근 수준만 지원합니다. 개별 사용자와 그룹은 지정할 수 없습니다.

Warning

그룹의 보호된 브랜치 설정은 최상위 그룹으로만 제한됩니다.

유효한 접근 수준#

접근 수준은 ProtectedRefAccess.allowed_access_levels 메서드에 정의되어 있습니다. 다음 수준이 인식됩니다:

0  => 접근 없음
30 => Developer 접근
40 => Maintainer 접근
60 => Admin 접근

보호된 브랜치 목록 조회#

그룹에서 보호된 브랜치 목록을 가져옵니다. 와일드카드가 설정된 경우 해당 와일드카드와 일치하는 브랜치의 정확한 이름 대신 와일드카드가 반환됩니다.

GET /groups/:id/protected_branches
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
search 문자열 아니요 검색할 보호된 브랜치의 이름 또는 이름의 일부.
curl --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches"

응답 예시:

[
  {
    "id": 1,
    "name": "main",
    "push_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "merge_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
  },
  {
    "id": 1,
    "name": "release/*",
    "push_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "merge_access_levels": [
      {
        "id":  1,
        "access_level": 40,
        "user_id": null,
        "group_id": null,
        "access_level_description": "Maintainers"
      }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
  },
  ...
]

단일 보호된 브랜치 또는 와일드카드 보호된 브랜치 가져오기#

단일 보호된 브랜치 또는 와일드카드 보호된 브랜치를 가져옵니다.

GET /groups/:id/protected_branches/:name
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치 이름 또는 와일드카드.
curl --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/main"

응답 예시:

{
  "id": 1,
  "name": "main",
  "push_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "merge_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "allow_force_push":false,
  "code_owner_approval_required": false
}

저장소 브랜치 보호#

와일드카드 보호된 브랜치를 사용하여 단일 저장소 브랜치를 보호합니다.

POST /groups/:id/protected_branches
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches?name=*-stable&push_access_level=30&merge_access_level=30&unprotect_access_level=40"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치 이름 또는 와일드카드.
allow_force_push 불리언 아니요 푸시 접근 권한이 있는 모든 사용자가 강제 푸시할 수 있도록 허용합니다. 기본값: false.
allowed_to_merge 배열 아니요 머지가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
allowed_to_push 배열 아니요 푸시가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
allowed_to_unprotect 배열 아니요 보호 해제가 허용된 접근 수준의 배열. {user_id: integer}, {group_id: integer} 또는 {access_level: integer} 형식의 해시로 설명됩니다.
code_owner_approval_required 불리언 아니요 CODEOWNERS 파일의 항목과 일치하는 경우 이 브랜치로의 푸시를 방지합니다. 기본값: false.
merge_access_level 정수 아니요 머지가 허용된 접근 수준. 기본값: 40, Maintainer 역할.
push_access_level 정수 아니요 푸시가 허용된 접근 수준. 기본값: 40, Maintainer 역할.
unprotect_access_level 정수 아니요 보호 해제가 허용된 접근 수준. 기본값: 40, Maintainer 역할.

응답 예시:

{
  "id": 1,
  "name": "*-stable",
  "push_access_levels": [
    {
      "id":  1,
      "access_level": 30,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Developers + Maintainers"
    }
  ],
  "merge_access_levels": [
    {
      "id":  1,
      "access_level": 30,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Developers + Maintainers"
    }
  ],
  "unprotect_access_levels": [
    {
      "id":  1,
      "access_level": 40,
      "user_id": null,
      "group_id": null,
      "access_level_description": "Maintainers"
    }
  ],
  "allow_force_push":false,
  "code_owner_approval_required": false
}

접근 수준을 사용한 예시#

접근 수준을 사용하여 그룹 보호된 브랜치를 구성합니다:

curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --data '{
    "name": "main",
    "allowed_to_push": [{"access_level": 30}],
    "allowed_to_merge": [{
        "access_level": 30
      },{
        "access_level": 40
      }
    ]}'
    --url "https://gitlab.example.com/api/v4/groups/5/protected_branches"

응답 예시:

{
    "id": 5,
    "name": "main",
    "push_access_levels": [
        {
            "id": 1,
            "access_level": 30,
            "access_level_description": "Developers + Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "merge_access_levels": [
        {
            "id": 1,
            "access_level": 30,
            "access_level_description": "Developers + Maintainers",
            "user_id": null,
            "group_id": null
        },
        {
            "id": 2,
            "access_level": 40,
            "access_level_description": "Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "unprotect_access_levels": [
        {
            "id": 1,
            "access_level": 40,
            "access_level_description": "Maintainers",
            "user_id": null,
            "group_id": null
        }
    ],
    "allow_force_push":false,
    "code_owner_approval_required": false
}

저장소 브랜치 보호 해제#

지정된 보호된 브랜치 또는 와일드카드 보호된 브랜치의 보호를 해제합니다.

DELETE /groups/:id/protected_branches/:name
curl --request DELETE \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/*-stable"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치의 이름.

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 40,
         "access_level_description": "Maintainers",
         "user_id": null,
         "group_id": null
      }
   ]
}

보호된 브랜치 업데이트#

보호된 브랜치를 업데이트합니다.

PATCH /groups/:id/protected_branches/:name
curl --request PATCH \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/5/protected_branches/feature-branch?allow_force_push=true&code_owner_approval_required=true"
속성 유형 필수 설명
id 정수 또는 문자열 그룹의 ID 또는 URL 인코딩된 경로.
name 문자열 브랜치의 이름.
allow_force_push 불리언 아니요 활성화되면 이 브랜치에 푸시할 수 있는 구성원도 강제 푸시할 수 있습니다.
allowed_to_push 배열 아니요 해시로 설명된 푸시 접근 수준의 배열.
allowed_to_merge 배열 아니요 해시로 설명된 머지 접근 수준의 배열.
allowed_to_unprotect 배열 아니요 해시로 설명된 보호 해제 접근 수준의 배열.
code_owner_approval_required 불리언 아니요 CODEOWNERS 파일의 항목과 일치하는 경우 이 브랜치로의 푸시를 방지합니다. 기본값: false.

allowed_to_push, allowed_to_mergeallowed_to_unprotect 배열의 요소는 {access_level: integer} 형식이어야 합니다. 각 접근 수준은 유효한 접근 수준에서 유효한 값이어야 합니다.

  • 접근 수준을 업데이트하려면 해당 해시에서 access_levelid도 전달해야 합니다.
  • 접근 수준을 삭제하려면 _destroytrue로 설정하여 전달해야 합니다. 다음 예시를 참조하세요.

예시: push_access_level 레코드 생성#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{access_level: 40}]}' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 40,
         "access_level_description": "Maintainers",
         "user_id": null,
         "group_id": null
      }
   ]
}

예시: push_access_level 레코드 업데이트#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{"id": 12, "access_level": 0}]' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": [
      {
         "id": 12,
         "access_level": 0,
         "access_level_description": "No One",
         "user_id": null,
         "group_id": null
      }
   ]
}

예시: push_access_level 레코드 삭제#

curl --header 'Content-Type: application/json' --request PATCH \
  --data '{"allowed_to_push": [{"id": 12, "_destroy": true}]}' \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/groups/22034114/protected_branches/main"

응답 예시:

{
   "name": "main",
   "push_access_levels": []
}